<?php
/**
 * Nic_Device_mysql:: Nic_Device implementation to retrieve data from
 * a mysql server.
 *
 * @author  Mike Cochrane <mike@graftonhall.co.nz>
 * @since   Nic 0.2
 * @package Nic
 */
class Nic_Device_mysql extends Nic_Device {

    /* Array containing the details of graphs available for this device. */
    var $_graphs = array(
        array(
            'title' => 'MySql Usage',
            'axisLabel' => 'Kb / Second',
            'data' => array(
                array(
                    'source' => 'Bytes_received',
                    'legend' => 'Bytes Received',
                    'description' => 'The number of bytes recieved by MySql.',
                    'type' => NIC_DATA_COUNTER,
                    'scale_function' => '/',
                    'scale_factor' => 1024,
                ),
                array(
                    'source' => 'Bytes_sent',
                    'legend' => 'Bytes Sent',
                    'description' => 'The number of bytes sent by MySql.',
                    'type' => NIC_DATA_COUNTER,
                    'scale_function' => '/',
                    'scale_factor' => 1024,
                )
            )
        ),
        array(
            'title' => 'MySql Usage',
            'axisLabel' => 'Connections / Second',
            'data' => array(
                array(
                    'source' => 'Connections',
                    'legend' => 'Connections',
                    'description' => 'The number of connections made to MySql.',
                    'type' => NIC_DATA_COUNTER,
                )
            )
        ),
        array(
            'title' => 'MySql Usage',
            'axisLabel' => 'Queries / Second',
            'data' => array(
                array(
                    'source' => 'Questions',
                    'legend' => 'Queries',
                    'description' => 'The number of query made to MySql.',
                    'type' => NIC_DATA_COUNTER,
                )
            )
        ),
    );

    function Nic_Device_mysql($params = array())
    {
        $this->params = $params;
        $this->params['hostspec']  = isset($this->params['hostspec']) ? $this->params['hostspec'] : 'localhost';
        $this->params['hostspec'] .= isset($this->params['port']) ? ":" . $this->params['port'] : '';
    }

    function getStatus()
    {
        $connection = @mysql_connect($this->params['hostspec'], $this->params['user'], $this->params['password']);

        $status = array();
        $status['message'] = '';
        if ($connection == false) {
            $status['status'] = NIC_STATUS_FAULT;
        } else {
            $status['status'] = NIC_STATUS_NORMAL;
        }
        return $status;
    }

    function showDetails($templatePath, $device_id)
    {
        include $templatePath . '/header.inc';

        $status = $this->getStatus();
        if ($status['status'] == NIC_STATUS_NORMAL) {
            $connection = mysql_connect($this->params['hostspec'], $this->params['user'], $this->params['password']);
            $results = mysql_query("SHOW STATUS", $connection);
            $row = mysql_fetch_row($results);
            while ($row !== false) {
                $description = $row[0];
                $value = $row[1];
                include $templatePath . '/row.inc';
                $row = mysql_fetch_row($results);
            }
        }

        foreach ($this->_graphs as $graph_id => $graph) {
            include $templatePath . '/row-graph.inc';
        }

        include $templatePath . '/footer.inc';
    }

    function retrieveStoreableData()
    {
        $data = array();

        $data_descriptions = array('Bytes_received', 'Bytes_sent', 'Connections', 'Questions');

        $status = $this->getStatus();
        if ($status['status'] == NIC_STATUS_NORMAL) {
            $connection = mysql_connect($this->params['hostspec'], $this->params['user'], $this->params['password']);
            $results = mysql_query("SHOW STATUS", $connection);
            $row = mysql_fetch_row($results);
            while ($row !== false) {
                $description = $row[0];
                $value = $row[1];

                if (in_array($description, $data_descriptions)) {
                    $data[$description]['value'] = $value;
                }

                $row = mysql_fetch_row($results);
            }
        }

        return $data;
    }

}
