<?php
/**
 * NIC base inclusion file.
 *
 * $Horde: nic/lib/base.php,v 1.29 2005/10/13 05:40:13 selsky Exp $
 *
 * This file brings in all of the dependencies that every NIC script
 * will need, and sets up objects that all scripts use.
 */

// Check for a prior definition of HORDE_BASE (perhaps by an
// auto_prepend_file definition for site customization).
if (!defined('HORDE_BASE')) {
    @define('HORDE_BASE', dirname(__FILE__) . '/../..');
}

// Load the Horde Framework core, and set up inclusion paths.
require_once HORDE_BASE . '/lib/core.php';

// Registry.
if (Util::nonInputVar('session_control') == 'readonly') {
    $registry = &Registry::singleton(HORDE_SESSION_READONLY);
} else {
    $registry = &Registry::singleton();
}
if (is_a(($pushed = $registry->pushApp('nic', !defined('AUTH_HANDLER'))), 'PEAR_Error')) {
    if ($pushed->getCode() == 'permission_denied') {
        Horde::authenticationFailureRedirect();
    }
    Horde::fatal($pushed, __FILE__, __LINE__, false);
}
$conf = &$GLOBALS['conf'];
@define('NIC_TEMPLATES', $registry->get('templates'));

// Notification system.
$notification = &Notification::singleton();
$notification->attach('status');

// Find the base file path of Nic.
@define('NIC_BASE', dirname(__FILE__) . '/..');

// Nic base library.
require_once NIC_BASE . '/lib/Nic.php';

// Horde libraries.
require_once 'Horde/Help.php';
require_once 'Horde/Text.php';

// Device config file.
global $devices;
require NIC_BASE . '/config/devices.php';
