-- $Horde: nic/scripts/sql/nic.sql,v 1.3 2006/12/13 04:58:20 chuck Exp $

CREATE TABLE nic_status (
    status_hostname     VARCHAR(50) DEFAULT '' NOT NULL,
    status_subsystem    VARCHAR(50) DEFAULT '' NOT NULL,
    status_status       INT DEFAULT 0 NOT NULL,
    status_time         INT DEFAULT 0 NOT NULL,
    status_comment      TEXT,
--
    PRIMARY KEY (status_hostname, status_subsystem, status_time)
);

CREATE INDEX status_time_idx ON nic_status (status_time);
CREATE INDEX status_subsystem_idx ON nic_status (status_subsystem);
CREATE INDEX status_hostname_idx ON nic_status (status_hostname);


CREATE TABLE nic_data (
    data_time         INT DEFAULT 0 NOT NULL,
    data_hostname     VARCHAR(50) DEFAULT '' NOT NULL,
    data_subsystem    VARCHAR(50) DEFAULT '' NOT NULL,
    data_item         VARCHAR(128) DEFAULT '' NOT NULL,
    data_value        VARCHAR(128) DEFAULT '' NOT NULL,
--
    PRIMARY KEY (data_time, data_hostname, data_subsystem, data_item)
);

CREATE INDEX data_hostname_idx ON nic_data (data_hostname);
CREATE INDEX data_subsystem_idx ON nic_data (data_subsystem);
CREATE INDEX data_item_idx ON nic_data (data_item);
